;Makro Buchung: erstellt von Michael Zurmhlen am 11.01.2002
;Ziel= nach Eingabe eines Zeitraums und eines Kontos wird die
;      Einnahmen- und Ausgaben-Summe gebildet
;Haupttabelle  = BUCHHLTG
;Hilfstabellen = BUKONTEN {mit Eintrag Nr. 1 = "...1) Bar..."},
;                SUMME-H, SUMME-S, AUSWERTG, BELEGE
;Zusatzprogr.  = LIST.COM und Textdatei SUMMEN.TXT        
;nderungen: 1.1- Erkennung von unvollstndigen Buchungen, evtl. Lschung
;            1.2- Berechnung Vorsteuer / Umsatzsteuer
;            1.3- Eingabe neuer Konten
;            1.4- Anzeige monatlicher Summen als Report BUCHHLTG.R
;            1.5- Suchen in Datumsfeldern
;            1.6- selbststndiger Eintrag des aktuellen Verzeichnisses
;            1.7- Suchen vom Ende der Tabelle (aktuelleren Datums)
;            2.0- Rckfrage beim Lschen, Sammelreport in T-Konten-Form
;            2.1- Suchen in Buchungskonten
;            2.2- Fehlerbehebung Berechnung Sammelreport (F7)
;            3.0- Budget-Rechnung als zustzliches Feld, Untermen Reports
;            3.1- Taste F6 (Menpunkt Summen) und berprfung Grenzen Gruppen
;            3.2- Taste Alt-F3 fr unbedingte Erstsuche
;            3.3- Hilfe bei Belegfeld: Liste bisheriger Belege + bernahme
;            3.4- statt monatlicher nun Jahrs-Auswertung
;            3.5- zustzlich Summenreport ber alle Konten
;            3.6- Taste F7: bernahme des aktuellen Datensatzes in separater
;                 Eingabeliste zum leichteren kopieren gleichartiger Buchungen
;            3.7- Hilfe bei Gruppenfeld: Liste bisheriger Eintrge + bernahme
;            3.8- Einfgen der "Von" und "Bis"-Felder in Tabelle BuKonten 
;
;============================================================================
PROC Zeige_Menue ()
  SHOWPULLDOWN
    "X"
       :"Programm Version 3.8 beenden"
       :"CMD_Ende"
       SUBMENU
         "Ende"    :"Programm jetzt beenden"
                   :"CMD_EndeJa",
         "Sichern" :"Datensicherung und Programm beenden"
                   :"CMD_EndeSicher",
         "Ziel"    :"Zielpfad fr Datensicherung einstellen"
                   :"CMD_EndeZiel",
         "Service" :"Rckkehr zur PARADOX-Entwicklungsumgebung"
                   :"CMD_EndePDOX"
       ENDSUBMENU,
    "~F3~-Suchen"
       :"Bitte fr Suche erst gewnschtes Feld mit Pfeiltasten anwhlen"
       :"CMD_Such",
    "~F4~-Kasse"
       :"Kontostand ber Zeitraum ermitteln"
       :"CMD_Kasse",
    "~F5~-MwSt"
       :"Vorsteuer und Umsatzsteuer ber Zeitraum ermitteln"
       :"CMD_MwSt",
    "~F6~-Summen"
       :"Summen anzeigen, speichern oder ausdrucken"
       :"CMD_Summe"
       SUBMENU
         "Konto"    :"bersicht fr ein Konto ber Zeitraum in T-Form anzeigen"
                    :"CMD_Summe_K",
         "Gruppe"   :"bersicht fr eine Gruppe (Budget) ber Zeitraum in T-Form anzeigen"
                    :"CMD_Summe_B",
         "AlleJahre":"Nach Ausgaben sortierte Gesamtbersicht"
                    :"CMD_Summe_J",
         "Summen"   :"Einnahmen, Ausgaben, Salden aller Konten ber Zeitraum"
                    :"CMD_Summe_S"
       ENDSUBMENU,
    "~F7~-Multi"
       :"aktuellen Datensatz als Vorlage fr neue Eingabeliste verwenden"
       :"CMD_Multi",
     "~F8~-Konto"
       :"Neues Konto einrichten"
       :"CMD_Konto",
    "~F9~-Eintrag"
       :"Neuen Eintrag eingeben oder einen vorhandenen ndern"
       :"CMD_Edit"
  ENDMENU
  NeuPrompt ("Men mit F10 aktivieren, F1= Hilfe")
ENDPROC

PROC Zeige_Untermenue_Summen ()
  SHOWPOPUP "" @1, 33                  ;Position an SHOWPULLDOWN anpassen
         "Konto"    :"bersicht fr ein Konto ber Zeitraum in T-Form anzeigen"
                    :"CMD_Summe_K",
         "Gruppe"   :"bersicht fr ein Budget ber Zeitraum in T-Form anzeigen"
                    :"CMD_Summe_B",
         "AlleJahre":"Nach Ausgaben sortierte Gesamtbersicht"
                    :"CMD_Summe_J",
         "Summen"   :"Einnahmen, Ausgaben, Salden aller Konten ber Zeitraum"
                    :"CMD_Summe_S"
  ENDMENU
  TO Fkt
      SWITCH                           ;Menfunktionen aus ShowPulldown
        CASE Fkt = "CMD_Summe_K":    Summe_Konto ("Eins")
        CASE Fkt = "CMD_Summe_B":    Summe_Budget ()
        CASE Fkt = "CMD_Summe_J":    Report_Summen ("J")
        CASE Fkt = "CMD_Summe_S":    Summe_Konto ("Alle")
      ENDSWITCH                        ;von Switch Menutag
ENDPROC

PROC Gib_Hinweis (Hinweis_rot, Dauer)
  MESSAGE Hinweis_rot
  SLEEP Dauer
  MESSAGE ""
ENDPROC

PROC NeuPrompt (Hinweis_grau)
  IF PromptZeiger < 10
     THEN PromptZeiger = PromptZeiger +1
          PromptStack [PromptZeiger] = Hinweis_grau
          PROMPT Hinweis_grau
     ELSE Gib_Hinweis ("Systemfehler: zu tief geschachtelte Neu-Prompts", 3000)
          DEBUG
  ENDIF
ENDPROC

PROC AltPrompt ()
  IF (PromptZeiger > 1) AND (PromptZeiger <= 10)
     THEN PromptZeiger = PromptZeiger -1
          PROMPT (PromptStack [PromptZeiger])
     ELSE Gib_Hinweis ("Systemfehler: zu tief geschachtelte Alt-Prompts", 3000)
          DEBUG
  ENDIF
ENDPROC  

PROC Eingabe_Zielpfad ()
  DYNARRAY FensterArt []
  FensterArt ["HASFRAME"] = FALSE
  FensterArt ["HASSHADOW"] = FALSE
  FensterArt ["STYLE"] = 14+16         ;gelb auf blauem Grund
  WINDOW CREATE FLOATING @14, 10
         HEIGHT 4 WIDTH 60
         ATTRIBUTES FensterArt TO EingabeFenster
  @0, 0                                ;fr Rahmen-Anfang
  TEXT
Ŀ
                                                          
                                                          

  ENDTEXT
  STYLE ATTRIBUTE 14+16                ;gelb auf blauem Grund
  @1, 2 ?? "Bitte Zielpfad fr Datensicherung eingeben"
  @2, 2 ?? "-> "
  CURSOR NORMAL
  ACCEPT "A54" DEFAULT Zielpfad TO Zielpfad
  IF RETVAL = TRUE THEN                ;kein ESC gedrckt -> speichert Inhalt
     SAVEVARS Zielpfad                 ;von neuem Zielpfad in Savevars.sc
  ENDIF
  WINDOW CLOSE
ENDPROC

;----------------------------------------------------------------------------
PROC SucheRecord ()                    ;von hinten !
  ErstSuche   = (AltFeld <> FIELD ())  ;Nach Feldwechsel ist ErstSuche !
  AltFeld     = FIELD ()               ;nderung nachfhren
  StartRecord = RECNO ()               ;merken, ob was gefunden wurde
  Suchwert    = ""
  IF ErstSuche THEN
    DYNARRAY FensterArt []
    FensterArt ["HASFRAME"] = FALSE
    FensterArt ["HASSHADOW"] = FALSE
    FensterArt ["STYLE"] = 0+32        ;schwarz auf grnem Grund
    WINDOW CREATE FLOATING @14, 10
           HEIGHT 4 WIDTH 60
           ATTRIBUTES FensterArt TO SuchFenster
    @0, 0                              ;fr Rahmen-Anfang
    TEXT
Ŀ
                                                          
                                                          

    ENDTEXT
    STYLE ATTRIBUTE 15+32              ;weiss auf grnem Grund
    @1, 2 ?? "Suche nach ", FIELD (), "  (Abbruch mit ESC)"
    @2, 2 ?? "-> "
    SucheJa = FALSE
    CURSOR NORMAL
    SWITCH
      CASE (FIELDTYPE () = "N") OR
           (FIELDTYPE () = "$") OR
           (FIELDTYPE () = "S"):                      ;Zahlenfeld
        ACCEPT "N" TO Suchwert
        SucheJa = RETVAL
        SuchString = STRVAL (Suchwert)                ;= exakte Vorgabe
        WINDOW CLOSE
      CASE FIELDTYPE () = "D":                        ;Datumsfeld
        ACCEPT "D" TO Suchwert
        SucheJa = RETVAL
        SuchString = STRVAL (Suchwert)                ;komplettes Datum
        WINDOW CLOSE
      OTHERWISE:                                      ;Alpha-Feld
        ACCEPT "A54" TO Suchwert
        SucheJa = RETVAL
        SuchString = ".."+ Suchwert +".."             ;= mit Platzhaltern
        WINDOW CLOSE
    ENDSWITCH
  ENDIF
  IF NOT SucheJa
     THEN AltFeld = " "                ;... dann Init fr ErstSuche = TRUE
  ENDIF
  IF ErstSuche AND SucheJa THEN
     MESSAGE ("Bitte etwas Geduld fr's Suchen...")
     ECHO OFF
     MaxTreffer = 0                    ;Init Zhler
     ZOOM SELECT SuchString            ;1. Treffer suchen
     WHILE (RECNO () <> StartRecord)   ;wenn gefunden...
       StartRecord = RECNO ()          ;merken, dass was gefunden wurde
       MaxTreffer = MaxTreffer + 1     ;Trefferzahl vom Tabellenanfang
       ZOOMNEXT                        ;und weitersuchen
     ENDWHILE
     IF MaxTreffer = 0                 ;nichts gefunden ?
        THEN AltFeld = " "             ;... dann Init fr ErstSuche = TRUE
     ENDIF
     ECHO NORMAL
     MESSAGE ("")
  ENDIF
  IF NOT ErstSuche AND SucheJa THEN
     MESSAGE ("Bitte etwas Geduld fr's Suchen...")
     ECHO OFF
     MaxTreffer    = MaxTreffer -1     ;fr nchstes Mal
     TrefferZeiger = MaxTreffer -1     ;vorherigen Treffer suchen
     ZOOM SELECT SuchString            ;1. Treffer suchen
     WHILE (TrefferZeiger > 0) 
       ZOOMNEXT                        ;und weitersuchen
       TrefferZeiger = TrefferZeiger -1                                       ;und weitersuchen
     ENDWHILE
     IF MaxTreffer <= 1                ;nichts mehr zum Weitersuchen
        THEN AltFeld = " "             ;... dann Init fr ErstSuche = TRUE
     ENDIF
     ECHO NORMAL
     MESSAGE ("")
  ENDIF
ENDPROC

;----------------------------------------------------------------------------
PROC Eingabe_Zeitraum ()               ;Rckgabewerte: FALSE bei Abbruch,
                                       ;und global Ersttag und Letzttag
  Weiter = TRUE                        ;Vorgabewert
  Ersttag = DATEVAL  ("1.1."+STRVAL (YEAR (TODAY ())))
  Letzttag= DATEVAL ("31.12."+STRVAL (YEAR (TODAY ())))
  DYNARRAY FensterArt []
  FensterArt ["HASFRAME"] = FALSE
  FensterArt ["HASSHADOW"] = FALSE
  FensterArt ["STYLE"] = 0+48          ;schwarz auf trkisem Grund
  WINDOW CREATE FLOATING @14, 22
         HEIGHT 6 WIDTH 36
         ATTRIBUTES FensterArt TO SuchFenster
  @0, 0                                ;fr Rahmen-Anfang
  TEXT
Ŀ
                                  
                                  
                                  
                                  

  ENDTEXT
  STYLE ATTRIBUTE 15+48                ;weiss auf trkisem Grund
  @1, 2 ?? "Datum ... (Abbruch mit ESC)"
  @2, 2 ?? "Von : "
  CURSOR NORMAL
  ACCEPT "D" DEFAULT Ersttag TO Ersttag
  IF RETVAL = FALSE                    ;ESC gedrckt ?
     THEN Weiter = FALSE
     ELSE
       @3, 2 ?? "Bis : "
       ACCEPT "D" DEFAULT Letzttag TO Letzttag
  ENDIF
  WINDOW CLOSE                         ;Eingabefenster
  RETURN (Weiter)
ENDPROC

;----------------------------------------------------------------------------
PROC BildeBelegListe ()
  ECHO OFF
  QUERY

    Buchhltg |      Beleg      |
             | CheckDescending | 

  ENDQUERY
  DO_IT!                               ;erzeugt Tabelle ANSWER
  RENAME "Answer" "Belege"             ;und sichern in neuer Tabelle
  MaxZahlBelege = NRECORDS ("Belege")
  ARRAY BelegWerte   [MaxZahlBelege]
  ARRAY BelegHinweis [MaxZahlBelege]

  ListenNr = 1                         ;Init Zeiger auf Array
  SCAN                                 ;flle Auswahl-Array mit Werten
    BelegWerte   [ListenNr] = [Beleg]
    BelegHinweis [ListenNr] = " "
    ListenNr = ListenNr +1
  ENDSCAN
  CLEARIMAGE                           ;Tabelle BELEGE entfernen
  ALTSPACE {Desktop} {SurfaceQueries}  ;Abfrage nach oben
  CLEARIMAGE                           ; und entfernen
ENDPROC

;----------------------------------------------------------------------------
PROC BildeGruppenListe ()
  ECHO OFF
  QUERY

    Buchhltg |      Gruppe     |
             | CheckDescending | 

  ENDQUERY
  DO_IT!                               ;erzeugt Tabelle ANSWER
  RENAME "Answer" "Gruppen"            ;und sichern in neuer Tabelle
  MaxZahlGruppen = NRECORDS ("Gruppen")
  ARRAY GruppenWerte   [MaxZahlGruppen]
  ARRAY GruppenHinweis [MaxZahlGruppen]

  ListenNr = 1                         ;Init Zeiger auf Array
  SCAN                                 ;flle Auswahl-Array mit Werten
    GruppenWerte   [ListenNr] = [Gruppe]
    GruppenHinweis [ListenNr] = " "
    ListenNr = ListenNr +1
  ENDSCAN
  CLEARIMAGE                           ;Tabelle GRUPPEN entfernen
  ALTSPACE {Desktop} {SurfaceQueries}  ;Abfrage nach oben
  CLEARIMAGE                           ; und entfernen
ENDPROC



;----------------------------------------------------------------------------
PROC Abfrage_Konten ()                 ;Rckgabe FALSE, wenn Abbruch
  MESSAGE "Fr die Summenbildung bitte etwas Geduld..."
  ECHO OFF
  CLEARALL                             ;leere Arbeitsflche
  
  Mit_Anzeige = Eingabe_Zeitraum ()
  IF Mit_Anzeige THEN
     QUERY

     Bukonten |   Abgang   |   Zugang   |    Von_Datum      |     Bis_Datum      |
     fast     | changeto 0 | changeto 0 | changeto ~Ersttag | changeto ~Letzttag |

     ENDQUERY
     DO_IT!                            ;lscht ohne ANSWER-Tabelle Werte in
     CLEARALL                          ;BUKONTEN, entfernt Abfrage vom Desktop

     QUERY

     Buchhltg |          Datum         |  Konto_von   |     Nettobetrag     |
              | >=~Ersttag,<=~Letzttag | Check _woher | calc sum as Summe-S | 

     ENDQUERY
     DO_IT!                            ;erzeugt Tabelle ANSWER = Ausgaben
     RENAME "Answer" "Summe-s"         ;und sichern in neuer Tabelle
     CLEARALL                          ;leere Arbeitsflche

     QUERY

     Buchhltg |          Datum         |   Konto_an   |     Nettobetrag     | 
              | >=~Ersttag,<=~Letzttag | Check _wohin | calc sum as Summe-H | 

     ENDQUERY
     DO_IT!                            ;erzeugt Tabelle ANSWER = Einnahmen
     RENAME "Answer" "Summe-h"         ;und sichern in neuer Tabelle
     CLEARALL                          ;leere Arbeitsflche

     QUERY

     Summe-h | Konto_an | Summe-H | 
             | _wohin   | _123H   | 

     Summe-s | Konto_von | Summe-S | 
             | _woher    | _123S   | 

     Bukonten | Buchungskonto |     Abgang     |     Zugang     |
     fast     | _wohin        |                | changeto _123H |
     fast     | _woher        | changeto _123S |                |

     ENDQUERY
     DO_IT!                            ;trgt ohne ANSWER-Tabelle Werte in
                                       ;BUKONTEN ein
     VIEW "Bukonten"
     EDITKEY
     SCAN
       [Saldo] = [Abgang] - [Zugang]   ;fr Sachkonten VZ richtig 
     ENDSCAN
     DO_IT!                            ;Beende Editmodus
     RETURN (TRUE)
  ELSE
     RETURN (FALSE)
  ENDIF
ENDPROC;

;-----------------------------------------------------------------------F-4--
PROC Abfrage_Kasse ()
  Mit_Anzeige = Abfrage_Konten ()
  IF Mit_Anzeige THEN
     MOVETO FIELD "Buchungskonto"
     LOCATE PATTERN "..1) Bar.."       ;suche Zeile mit Kasse
     Kasse = -[Saldo]                  ;merke Ergebnis fr Anzeige, VZ wegen Geldkonto
  ENDIF                                ;IF Mit_Anzeige
  CLEARALL                             ;leere Arbeitsflche
  VIEW "Buchhltg"                      ;Standardformular Kassenbuch
  IF NOT ISFORMVIEW ()
     THEN FORMKEY                      ;auf jeden Fall als Multirecord-Formular
  ENDIF
  MOVETO "Buchhltg"
  MOVETO FIELD "Datum"
  LOCATE INDEXORDER BESTMATCH TODAY () ;suche Eintrag am aktuellen oder nchsten Tag
  CTRLPGUP                             ;ein Record vorher mit Bildscroll
  CTRLPGDN                             ;zurck zum gefundenen Record
  WINMAX
  ECHO NORMAL
  IF Mit_Anzeige THEN
     Message ("Kassenbestand = "+STRVAL (Kasse)+" EUR        (weiter mit Taste)")
     Taste = GETCHAR ()                ;warte auf Taste, um lesen zu knnen
  ENDIF
ENDPROC

;-----------------------------------------------------------------------F-5--
PROC Abfrage_Steuer ()
  ECHO OFF
  CLEARALL                             ;leere Arbeitsflche
  
  Mit_Anzeige = Eingabe_Zeitraum ()
  IF Mit_Anzeige THEN
     QUERY

     Buchhltg |          Datum         | Konto_von |     Umsatzsteuer    |
              | >=~Ersttag,<=~Letzttag |   _Name   | calc sum as Summe-S | 

     Bukonten | Buchungskonto | Kontentyp | 
              | _Name         | "$"       | 

     ENDQUERY
     DO_IT!                            ;erzeugt Tabelle ANSWER = Vorsteuer
     IF ISBLANK ([Summe-S])
        THEN Vorsteuer = 0.00
        ELSE Vorsteuer = [Summe-S]     ;und sichern in Variablen
     ENDIF
     CLEARALL                          ;leere Arbeitsflche

     QUERY

     Buchhltg |          Datum         | Konto_an |     Umsatzsteuer    | 
              | >=~Ersttag,<=~Letzttag |   _Name  | calc sum as Summe-H | 

     Bukonten | Buchungskonto | Kontentyp | 
              | _Name         | "$"       | 

     ENDQUERY
     DO_IT!                            ;erzeugt Tabelle ANSWER = Umsatzsteuer
     IF ISBLANK ([Summe-H])
        THEN Umssteuer = 0.00
        ELSE Umssteuer = [Summe-H]     ;und sichern in Variablen
     ENDIF
     CLEARALL                          ;leere Arbeitsflche
  ENDIF                                ;IF Mit_Anzeige
  VIEW "Buchhltg"                      ;Standardformular Kassenbuch
  IF NOT ISFORMVIEW ()
     THEN FORMKEY                      ;auf jeden Fall als Multirecord-Formular
  ENDIF
  MOVETO "Buchhltg"
  MOVETO FIELD "Datum"
  LOCATE INDEXORDER BESTMATCH TODAY ()
  CTRLPGUP                             ;ein Record vorher mit Bildscroll
  CTRLPGDN                             ;zurck zum gefundenen Record
  WINMAX
  ECHO NORMAL
  IF Mit_Anzeige THEN
     Message ("Ausg. Vorsteuer = "+STRVAL (Vorsteuer)+" EUR        (weiter mit Taste)")
     Taste = GETCHAR ()                ;warte auf Taste, um lesen zu knnen
     Message ("Eing. MwSt = "+STRVAL (Umssteuer)+" EUR        (weiter mit Taste)")
     Taste = GETCHAR ()                ;warte auf Taste, um lesen zu knnen
  ENDIF
ENDPROC

;-----------------------------------------------------------------------F-6--
PROC Report_Summen (ListTyp)
  MESSAGE "Fr die Summenbildung bitte etwas Geduld..."
  ECHO OFF
  SWITCH
    CASE ListTyp = "M":      ;Monats-Auswertung
      MENU {Report} {Output} {Buchhltg} {R} {File} {Summen.txt} {Replace}
    CASE ListTyp = "J":      ;Jahres-Auswertung
      MENU {Report} {Output} {Buchhltg} {3} {File} {Summen.txt} {Replace}
    CASE ListTyp = "K":      ;Konto-Auswertung
      MENU {Report} {Output} {Auswertg} {1} {File} {Summen.txt} {Replace}
    CASE ListTyp = "B":      ;Budget-Auswertung
      MENU {Report} {Output} {Auswertg} {2} {File} {Summen.txt} {Replace}
    CASE ListTyp = "S":      ;Summen-Auswertung aller Konten
      MENU {Report} {Output} {Bukonten} {R} {File} {Summen.txt} {Replace}
  ENDSWITCH
  MESSAGE ""
  RUN NOSHELL "List.com Summen.txt"
  ECHO NORMAL
ENDPROC

;-----------------------------------------------------------------------F-6--
PROC Summe_Konto (Alle)
  ECHO OFF
  CLEARALL                             ;leere Arbeitsflche
  ARRAY KontenName [NRECORDS ("Bukonten")]
  ARRAY Kontentext [NRECORDS ("Bukonten")]
  ListenNr = 1                         ;Init Zeiger auf Array

  IF Alle = "Eins" THEN
     VIEW "Bukonten"
     SCAN                              ;flle Auswahl-Array mit Werten
       KontenName [ListenNr] = [Buchungskonto]
       Kontentext [ListenNr] = " "
       ListenNr = ListenNr +1
     ENDSCAN
     CLEARIMAGE                 ;Tabelle BUKONTEN wird nicht mehr gebraucht
     NeuPrompt ("Fr Gesamtbersicht bitte Konto mit ENTER besttigen, Abbruch mit ESC")
     ECHO NORMAL
     SHOWARRAY KontenName Kontentext TO Suchwert
     IF Suchwert <> "Esc"       ;Abbruch bei Konto-Auswahl ?
        THEN Mit_Anzeige = Eingabe_Zeitraum ()
        ELSE Mit_Anzeige = FALSE
     ENDIF
     RELEASE VARS KontenName, Kontentext  ;Speicherplatz wieder freigeben
     AltPrompt ()
  ELSE
     Mit_Anzeige = Eingabe_Zeitraum ()    ;nur Zeitraum festlegen fr alle Konten
     Suchwert = ""
  ENDIF

  ECHO OFF
  EMPTY "Auswertg"           ;alte Eintrge lschen
  IF Mit_Anzeige THEN        ;sowohl Zeitraum als auch Konto ausgesucht !
     QUERY

     Bukonten |   Abgang   |   Zugang   |    Von_Datum      |     Bis_Datum      |
     fast     | changeto 0 | changeto 0 | changeto ~Ersttag | changeto ~Letzttag |

     ENDQUERY
     DO_IT!                            ;lscht ohne ANSWER-Tabelle Werte in
     CLEARALL                          ;BUKONTEN, entfernt Abfrage vom Desktop

     QUERY

     Buchhltg |          Datum         |  Konto_von   |     Nettobetrag     |
              | >=~Ersttag,<=~Letzttag | Check _woher | calc sum as Summe-S | 

     ENDQUERY
     DO_IT!                            ;erzeugt Tabelle ANSWER = Ausgaben
     RENAME "Answer" "Summe-s"         ;und sichern in neuer Tabelle
     CLEARALL                          ;leere Arbeitsflche

     QUERY

     Buchhltg |          Datum         |   Konto_an   |     Nettobetrag     | 
              | >=~Ersttag,<=~Letzttag | Check _wohin | calc sum as Summe-H | 

     ENDQUERY
     DO_IT!                            ;erzeugt Tabelle ANSWER = Einnahmen
     RENAME "Answer" "Summe-h"         ;und sichern in neuer Tabelle
     CLEARALL                          ;leere Arbeitsflche

     QUERY

     Summe-h | Konto_an | Summe-H | 
             | _wohin   | _123H   | 

     Summe-s | Konto_von | Summe-S | 
             | _woher    | _123S   | 

     Bukonten | Buchungskonto |     Abgang     |     Zugang     |
     fast     | _wohin        |                | changeto _123H |
     fast     | _woher        | changeto _123S |                |

     ENDQUERY
     DO_IT!                            ;trgt ohne ANSWER-Tabelle Werte in
                                       ;BUKONTEN ein
     VIEW "Bukonten"
     EDITKEY
     SCAN
       [Saldo] = [Abgang] - [Zugang]   ;fr Sachkonten VZ richtig 
     ENDSCAN
     DO_IT!                            ;Beende Editmodus

     QUERY

     Auswertg    | Datum | Konto_von | Konto_an | Nettobetrag | Beleg | 
     fast insert | _Dat1 | _Von1     | _An1     | _Euro1      | _Nr1  | 
     fast insert | _Dat2 | _Von2     | _An2     | _Euro2      | _Nr2  | 

     Auswertg    | Belegtext | Umsatzsteuer | Fuer_Konto | 
                 | _Text1    | _Mwst1       | ~Suchwert  | 
                 | _Text2    | _Mwst2       | ~Suchwert  | 

     Buchhltg |          Datum                |    Konto_von     |    Konto_an     | 
              | >=~Ersttag,<=~Letzttag, _Dat1 | ~Suchwert, _Von1 | _An1            | 
              | >=~Ersttag,<=~Letzttag, _Dat2 | _Von2            | ~Suchwert, _An2 | 

     Buchhltg | Nettobetrag | Beleg | Belegtext | Umsatzsteuer | 
              | _Euro1      | _Nr1  | _Text1    | _Mwst1       | 
              | _Euro2      | _Nr2  | _Text2    | _Mwst2       | 

     ENDQUERY
     DO_IT!                            ;trgt ohne ANSWER-Tabelle Werte in
                                       ;AUSWERTG ein
     IF Alle = "Eins"
        THEN Report_Summen ("K")       ;Anzeige des Reports Auswertg.R1
        ELSE Report_Summen ("S")       ;Anzeige des Reports Bukonten.R
     ENDIF
  ENDIF                                ;von if Mit_Anzeige
  CLEARALL                             ;leere Arbeitsflche
  VIEW "Buchhltg"                      ;Standardformular Kassenbuch
  IF NOT ISFORMVIEW ()
     THEN FORMKEY                      ;auf jeden Fall als Multirecord-Formular
  ENDIF
  MOVETO "Buchhltg"
  MOVETO FIELD "Datum"
  LOCATE INDEXORDER BESTMATCH TODAY ()
  CTRLPGUP                             ;ein Record vorher mit Bildscroll
  CTRLPGDN                             ;zurck zum gefundenen Record
  WINMAX
  ECHO NORMAL
ENDPROC

;-----------------------------------------------------------------------------
PROC Summe_Budget()
  ECHO OFF
  CLEARALL                             ;leere Arbeitsflche
  QUERY

  Buchhltg |      Gruppe      | 
           | CheckDescending  | 

  ENDQUERY
  DO_IT!                               ;erzeugt ANSWER-Tabelle mit allen Budgets
  IF NRECORDS ("Answer") >=1 AND NRECORDS ("Answer") <=15000 THEN
     ARRAY KontenName [NRECORDS ("Answer")]
     ARRAY Kontentext [NRECORDS ("Answer")]
     ListenNr = 1                      ;Init Zeiger auf Array

     VIEW "Answer"
     SCAN                              ;flle Auswahl-Array mit Werten
       KontenName [ListenNr] = [Gruppe]
       Kontentext [ListenNr] = " "
       ListenNr = ListenNr +1
     ENDSCAN
     CLEARALL                          ;Tabelle ANSWER wird nicht mehr gebraucht
     NeuPrompt ("Fr Gesamtbersicht bitte Gruppe mit ENTER besttigen, Abbruch mit ESC")
     ECHO NORMAL
     SHOWARRAY KontenName Kontentext TO Suchwert
     IF Suchwert <> "Esc"              ;Abbruch bei Konto-Auswahl ?
        THEN Mit_Anzeige = Eingabe_Zeitraum ()
        ELSE Mit_Anzeige = FALSE
     ENDIF
     RELEASE VARS KontenName, Kontentext  ;Speicherplatz wieder freigeben
     AltPrompt ()
  ELSE
     Mit_Anzeige = FALSE
     Gib_Hinweis ("noch keine Gruppen angelegt !", 3000)
     RELEASE VARS KontenName, Kontentext  ;Speicherplatz wieder freigeben
  ENDIF
  ECHO OFF
  EMPTY "Auswertg"           ;alte Eintrge lschen
  IF Mit_Anzeige THEN        ;sowohl Zeitraum als auch Budget ausgesucht !
     QUERY

     Bukonten |    Von_Datum      |     Bis_Datum      |
     fast     | changeto ~Ersttag | changeto ~Letzttag |

     ENDQUERY
     DO_IT!                            ;ndert ohne ANSWER-Tabelle Werte in
     CLEARALL                          ;BUKONTEN
     QUERY

     Auswertg | Datum | Konto_von | Konto_an | Nettobetrag |  Beleg  | 
     insert   | _Dat1 | _Von1     | _An1     | _Euro1      | _Beleg1 | 
     insert   | _Dat2 | _Von2     | _An2     | _Euro2      | _Beleg2 | 

     Auswertg | Belegtext | Umsatzsteuer |  Gruppe   | Fuer_Konto | 
              | _Text1    | _MwSt1       | ~Suchwert | _An1       | 
              | _Text2    | _MwSt2       | ~Suchwert | _Von2      | 

     Buchhltg |              Datum           |  Konto_von   |  Konto_an   | 
              | >=~Ersttag,<=~Letzttag,_Dat1 | _Von1,_Geld1 | _An1        |
              | >=~Ersttag,<=~Letzttag,_Dat2 | _Von2        | _An2,_Geld2 |

     Buchhltg | Nettobetrag |  Beleg  | Belegtext |  Gruppe   | Umsatzsteuer | 
              | _Euro1      | _Beleg1 |  _Text1   | ~Suchwert | _MwSt1       | 
              | _Euro2      | _Beleg2 |  _Text2   | ~Suchwert | _MwSt2       | 

     Bukonten | Buchungskonto | Kontentyp | 
              | _Geld1        | "$"       | 
              | _Geld2        | "$"       | 

     ENDQUERY
     DO_IT!                            ;erzeugt Zeilen in AUSWERTG aus BUCHHLTG
     CLEARALL                          ;auch Tabelle INSERTED entfernen
     QUERY

     Auswertg | Konto_an |         Nettobetrag         | Fuer_Konto | 
              | _An1     | _Euro1, calc sum as Summe-H | _An1       | 

     Auswertg |       Gruppe        | 
              | Check as "Konto_an" | 

     ENDQUERY
     DO_IT!                            ;berechne Summe aller rechten Seiten
     RENAME "Answer" "Summe-h"         ;und sichern in neuer Tabelle
     {Modify} {Restructure} {Summe-h} Right Right
     "*" Do_It!                        ;Indexfeld wegen Report (Nachschlagen)
     CLEARALL                          ;leere Arbeitsflche
     QUERY

     Auswertg | Konto_von |         Nettobetrag         | Fuer_Konto | 
              | _Von1     | _Euro1, calc sum as Summe-S | _Von1      | 

     Auswertg |        Gruppe        | 
              | Check as "Konto_von" | 

     ENDQUERY
     DO_IT!                            ;berechne Summe aller linken Seiten
     RENAME "Answer" "Summe-s"         ;und sichern in neuer Tabelle
     {Modify} {Restructure} {Summe-s} Right Right
     "*" Do_It!                        ;Indexfeld wegen Report (Nachschlagen)
     CLEARALL                          ;leere Arbeitsflche
     Report_Summen ("B")               ;Anzeige des Reports
  ENDIF                                ;von if Mit_Anzeige
  CLEARALL                             ;leere Arbeitsflche
  VIEW "Buchhltg"                      ;Standardformular Kassenbuch
  IF NOT ISFORMVIEW ()
     THEN FORMKEY                      ;auf jeden Fall als Multirecord-Formular
  ENDIF
  MOVETO "Buchhltg"
  MOVETO FIELD "Datum"
  LOCATE INDEXORDER BESTMATCH TODAY ()
  CTRLPGUP                             ;ein Record vorher mit Bildscroll
  CTRLPGDN                             ;zurck zum gefundenen Record
  WINMAX
  ECHO NORMAL
ENDPROC


;---------------------------------------------------------------H-I-L-F-E----
PROC Hilfe_F1 (Merkmal)
  SWITCH
    CASE (Merkmal = "Beleg") AND (SYSMODE () <> "Main"):
      NeuPrompt ("letzten Beleg als Vorlage auswhlen und mit ENTER besttigen")
      ECHO NORMAL
      SHOWARRAY BelegWerte BelegHinweis TO Suchwert
      IF Suchwert <> "Esc" THEN
         [Beleg] = Suchwert            ;bernommenen Eintrag eintragen
      ENDIF
      AltPrompt ()
    CASE (Merkmal = "Gruppe") AND (SYSMODE () <> "Main"):
      NeuPrompt ("letzten Eintrag als Vorlage auswhlen und mit ENTER besttigen")
      ECHO NORMAL
      SHOWARRAY GruppenWerte GruppenHinweis TO Suchwert
      IF Suchwert <> "Esc" THEN
         [Gruppe] = Suchwert           ;bernommenen Eintrag eintragen
      ENDIF
      AltPrompt ()
    CASE Merkmal = "Datum":
      Gib_Hinweis ("Datum bitte mit 4-stelliger Jahreszahl eingeben", 2000)
    CASE Merkmal = "Nettobetrag":
      Gib_Hinweis ("Wert bitte mit Komma eingeben", 2000)
    OTHERWISE:
      Gib_Hinweis ("Noch keine Hilfe fr "+ Merkmal +" verfgbar !", 2000)
    ENDSWITCH
  WaitReturn = 1                       ;Funktion ist abgearbeitet
ENDPROC

;---------------------------------------------------------------S-U-C-H-E----
PROC Funktion_F3 ()
  SucheRecord ()
  WaitReturn = 1                       ;Funktion ist abgearbeitet
ENDPROC
  
;****************************************************************************
PROC Auswert_Edit (EreignisTyp, EreignisRecord, ZyklusNr)
  WaitReturn = 0                       ;Voreinstellung = weiter an Paradox
  Ausfuellcode = 0                     ;Startwert
  IF NOT ISBLANK ([Datum]) THEN
     Ausfuellcode = Ausfuellcode +8
  ENDIF
  IF NOT ISBLANK ([Konto_von]) THEN
     Ausfuellcode = Ausfuellcode +4
  ENDIF
  IF NOT ISBLANK ([Konto_an]) THEN
     Ausfuellcode = Ausfuellcode +2
  ENDIF
  IF NOT ISBLANK ([Nettobetrag]) THEN
     Ausfuellcode = Ausfuellcode +1
  ENDIF
  SWITCH
    CASE EreignisTyp = "DEPARTROW":
      SWITCH
        CASE Ausfuellcode = 15:        ;alles vollstndig
          IF RECORDSTATUS ("KeyViol") THEN
             Gib_Hinweis ("Diese Buchung gibt es schon, ndern oder lschen !", 1500)
          ENDIF
          WaitReturn = 0               ;Steuerung an Paradox weitergeben
        CASE (Ausfuellcode >= 10) OR   ;Datum und min. ein Konto
             (Ausfuellcode = 6):       ;oder beide Konten angegeben
          Gib_Hinweis ("Bitte erst alle wichtigen Felder ausfllen !", 1000)
          WaitReturn = 1               ;Wait Table weitermachen
        OTHERWISE:
          DEL                          ;Record lschen
          WaitReturn = 1               ;Wait Table weitermachen
      ENDSWITCH
    CASE EreignisTyp = "EVENT":
      Fkt = EreignisRecord ["KEYCODE"]
      SWITCH                           ;Tasten aus WAIT TABLE KEY-Liste
        CASE Fkt = ASC ("F1"):
          IF (FIELD () = "Konto_von") OR
             (FIELD () = "Konto_an") THEN
             HELP                      ;Tabelle BUKONTEN anzeigen
             WINMAX
             WHILE TRUE
             WAIT TABLE
               MESSAGE "Konto auswhlen und mit ENTER oder F2 besttigen"
             UNTIL "F2", "F3", "Enter", "Esc"
             SWITCH
               CASE (RETVAL = "Enter") OR (RETVAL = "F2"):
                 DO_IT!                ;Wert bernehmen, Edit-Ende
                 QUITLOOP
               CASE RETVAL = "Esc":
                 KEYPRESS "ESC"        ;Hilfe-Tabelle beenden
                 QUITLOOP
               CASE RETVAL = "F3":
                 MOVETO FIELD "Buchungskonto"
                 SucheRecord () 
                 RETVAL = ""
             ENDSWITCH
             ENDWHILE
          ELSE Hilfe_F1 (FIELD ())     ;allgemeine Hilfe
          ENDIF
          WaitReturn = 1               ;Wait Table weitermachen
        CASE Fkt = ASC ("F2"):         ;Fertig mit Eingaben
          SWITCH
            CASE Ausfuellcode = 15:    ;alles vollstndig
              ECHO OFF                        
              DO_IT!                   ;Versuchen, CoEdit zu beenden
              IF SYSMODE () = "CoEdit"
                 THEN
                   DO_IT!              ;Versuchen, CoEdit zu beenden
                   IF SYSMODE () = "CoEdit"
                      THEN DEBUG       ;Fehler trotz 2x DO_IT
                   ENDIF
              ENDIF
              WaitReturn = 2           ;Wait Table verlassen
            CASE (Ausfuellcode >= 10) OR   ;Datum und min. ein Konto
                 (Ausfuellcode = 6):   ;oder beide Konten angegeben
              Gib_Hinweis ("Bitte erst alle wichtigen Felder ausfllen !", 1000)
              WaitReturn = 1           ;Wait Table weitermachen
            OTHERWISE:
              DEL                      ;Record lschen
              ECHO OFF                        
              DO_IT!                   ;Versuchen, CoEdit zu beenden
              IF SYSMODE () = "CoEdit"
                 THEN DEBUG            ;Fehler ?
              ENDIF
              WaitReturn = 2           ;Wait Table verlassen
          ENDSWITCH                    ;von Switch Ausfuellcode
        CASE Fkt = ASC ("F3"):         ;Suchen
          Funktion_F3 ()
        CASE Fkt = ASC ("F33"):        ;Suchen (unbedingte Erstsuche)
          AltFeld = " "
          Funktion_F3 ()
        CASE Fkt = ASC ("F9"):         ;Buchung
          INS
          WaitReturn = 1               ;Wait Table weitermachen
        CASE Fkt = ASC ("Esc"):
          ECHO OFF
          UNDO                         ;nderungen zurcknehmen
          DO_IT!                       ;CoEdit Abbrechen
          WaitReturn = 2               ;Wait Table verlassen
        CASE (Fkt = ASC ("Del")) AND NOT ISFIELDVIEW ():
          SHOWPOPUP "Buchung "+[Belegtext]+" lschen ?" CENTERED
            "Nein": "ein Versehen...": "CMD_Loesch_N",
            " Ja ": "Besttigen !"   : "CMD_Loesch_J"
          ENDMENU TO Auswahl
          IF Auswahl = "CMD_Loesch_J"
             THEN DEL                  ;Record lschen
          ENDIF
          WaitReturn = 1               ;Wait Table weitermachen
        CASE (Fkt = ASC ("Del")) AND ISFIELDVIEW ():
          DEL                          ;einzelnes Zeichen lschen
          WaitReturn = 1               ;Wait Table weitermachen
      ENDSWITCH                        ;von Switch Fkt
  ENDSWITCH                            ;von Switch EreignisTyp
  RETURN WaitReturn
ENDPROC

;****************************************************************************
PROC Auswert_Edit_Konto (EreignisTyp, EreignisRecord, ZyklusNr)
  WaitReturn = 0                       ;Voreinstellung = weiter an Paradox
  IF EreignisTyp = "EVENT" THEN
     Fkt = EreignisRecord ["KEYCODE"]
     SWITCH                            ;Tasten aus WAIT RECORD KEY-Liste
       CASE Fkt = ASC ("F1"):
         Hilfe_F1 (FIELD ())           ;allgemeine Hilfe
         WaitReturn = 1                ;Wait Record weitermachen
       CASE (Fkt = ASC ("F2")) OR
            (Fkt = ASC ("Enter")):     ;Fertig mit Eingaben
         ECHO OFF                        
         IF NOT ISBLANK ([Buchungskonto])
            THEN DO_IT!                ;Versuchen, CoEdit zu beenden
              IF SYSMODE () = "CoEdit"
                 THEN UNDO             ;doppelten Eintrag lschen
                 DO_IT!                ;CoEdit Abbrechen
              ENDIF
            ELSE
              UNDO                     ;nderungen zurcknehmen
              DO_IT!                   ;CoEdit Abbrechen
         ENDIF     
         WaitReturn = 2                ;Wait Record verlassen
       CASE Fkt = ASC ("F3"):          ;Suchen
         Funktion_F3 ()
       CASE Fkt = ASC ("F33"):         ;Suchen (unbedingte Erstsuche)
         AltFeld = " "
         Funktion_F3 ()
       CASE Fkt = ASC ("Esc"):
         ECHO OFF
         UNDO                          ;nderungen zurcknehmen
         DO_IT!                        ;CoEdit Abbrechen
         WaitReturn = 2                ;Wait Record verlassen
     ENDSWITCH                         ;von Switch Fkt
  ENDIF                                ;von If EreignisTyp
  RETURN WaitReturn
ENDPROC

;-----------------------------------------------------B-U-C-H-U-N-G---N-E-U--
PROC Buchung_Neu ()
  ECHO OFF
  BildeBelegListe ()
  BildeGruppenListe ()

  IF NOT ISFORMVIEW ()
     THEN FORMKEY                      ;auf jeden Fall als Eingabe-Formular
  ENDIF
  WINMAX
  MOVETO FIELD "Datum"
  COEDITKEY
  INS                                  ;leere Zeile erzeugen
  NeuPrompt ("Konto: F1= Liste | Zeile: Entf / Einfg | F2= alles fertig | ESC= Abbruch")
  WAIT TABLE
    PROC    "Auswert_Edit"             ;Auswertung bei...
    TRIGGER "ALL"                      ;...Record verlassen oder bei
    KEY     "F1","F2","F3","F33","F9","Esc","Del","Ins"
                                       ;...Tasten siehe Prompt
  ENDWAIT
  AltPrompt ()
  RELEASE VARS BelegWerte, BelegHinweis
  ECHO NORMAL
  WaitReturn = 1                       ;Funktion ist abgearbeitet
ENDPROC

;---------------------------------------------------------K-O-N-T-O---N-E-U--
PROC Konto_Neu ()
  ECHO OFF
  IF NOT ISFORMVIEW ()
     THEN FORMKEY                      ;auf jeden Fall als Eingabe-Formular
  ENDIF
  WINMAX
  COEDITKEY
  INS                                  ;leere Zeile erzeugen
  NeuPrompt ("Enter oder F2= alles fertig | ESC= Abbruch")
  WAIT RECORD
    PROC    "Auswert_Edit_Konto"       ;Auswertung bei...
    KEY     "F1","F2","F3","F33","Enter","Esc"
                                       ;...Tasten siehe Prompt
  ENDWAIT
  AltPrompt ()
  ECHO NORMAL
  WaitReturn = 2                       ;Ende von WAIT Bukonten -> Buchhltg  
  HP_Tabelle = "Buchhltg"
  MESSAGE "gleich erfolgt die Umschaltung auf das Kassenbuch !"
  SLEEP 2000                           ;noch fr kurze Zeit Ergebnis sichtbar
  MESSAGE ""
ENDPROC


;****************************************************************************
PROC Auswert_Buchung (EreignisTyp, EreignisRecord, ZyklusNr)
  WaitReturn = 0                       ;Voreinstellung = weiter an Paradox
  SWITCH
    CASE EreignisRecord ["TYPE"] = "KEY":
      Fkt = EreignisRecord ["KEYCODE"]
      SWITCH                           ;Tasten aus WAIT TABLE KEY-Liste
        CASE Fkt = ASC ("F1"):       Hilfe_F1 (FIELD ())
        CASE Fkt = ASC ("F2"):       Gib_Hinweis ("Buchungs-Modus ist schon beendet !", 1000)
        CASE Fkt = ASC ("F3"):       Funktion_F3 ()
        CASE Fkt = ASC ("F33"):      AltFeld = " "
                                     Funktion_F3 ()
        CASE Fkt = ASC ("F4"):       Abfrage_Kasse ()
        CASE Fkt = ASC ("F5"):       Abfrage_Steuer ()
        CASE Fkt = ASC ("F6"):       Zeige_Untermenue_Summen ()
        CASE Fkt = ASC ("F7"):
          COPYTOARRAY Vorlagesatz      ;merke aktuellen Datensatz
          EMPTY "Einglist"
          WaitReturn = 2               ;Ende von WAIT Buchhltg -> Einglist
          HP_Tabelle = "Einglist"
         CASE Fkt = ASC ("F8"):
          WaitReturn = 2               ;Ende von WAIT Buchhltg -> Bukonten
          HP_Tabelle = "Bukonten"
        CASE Fkt = ASC ("F9"):       Buchung_Neu ()
        OTHERWISE:
          Gib_Hinweis ("Taste "+STRVAL (EreignisRecord ["KEYCODE"])
                      +" ist nicht definiert", 3000)
      ENDSWITCH
    CASE EreignisRecord ["MESSAGE"] = "MENUSELECT":
      Fkt = EreignisRecord ["MENUTAG"]
      SWITCH                           ;Menfunktionen aus ShowPulldown
        CASE Fkt = "CMD_Such":       Funktion_F3 ()
        CASE Fkt = "CMD_Kasse":      Abfrage_Kasse ()
        CASE Fkt = "CMD_MwSt":       Abfrage_Steuer ()
        CASE Fkt = "CMD_Summe_K":    Summe_Konto ("Eins")
        CASE Fkt = "CMD_Summe_S":    Summe_Konto ("Alle")
        CASE Fkt = "CMD_Summe_B":    Summe_Budget ()
        CASE Fkt = "CMD_Summe_J":    Report_Summen ("J")
        CASE Fkt = "CMD_Multi":
          COPYTOARRAY Vorlagesatz      ;merke aktuellen Datensatz
          EMPTY "Einglist"
          WaitReturn = 2               ;Ende von WAIT Buchhltg -> Einglist
          HP_Tabelle = "Einglist"
        CASE Fkt = "CMD_Konto":
          WaitReturn = 2               ;Ende von WAIT Buchhltg -> Bukonten
          HP_Tabelle = "Bukonten"
        CASE Fkt = "CMD_Edit":       Buchung_Neu ()
        CASE Fkt = "CMD_EndePDOX":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Quit"
        CASE Fkt = "CMD_EndeJa":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Ende"
        CASE Fkt = "CMD_EndeZiel":
          Eingabe_Zielpfad ()          ;bleibe im WAIT Buchhltg
        CASE Fkt = "CMD_EndeSicher":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Ende"
          MESSAGE "Datensicherung aktiv !"
          SAVETABLES                   ;alle Tabellen schliessen
          RUN NOSHELL "XCOPY.EXE *.* " + Zielpfad
        OTHERWISE:
          Gib_Hinweis ("Die Reaktion auf "+EreignisRecord ["MENUTAG"]
                      +" ist noch nicht programmiert !", 3000)
      ENDSWITCH                        ;von Switch Menutag
    OTHERWISE:
      Gib_Hinweis ("Das Ereignis "+EreignisRecord ["MESSAGE"]
                  +" ist noch nicht programmiert !", 3000)
  ENDSWITCH                            ;von Switch EreignisRecord
  RETURN WaitReturn
ENDPROC

;****************************************************************************
PROC Auswert_Konten (EreignisTyp, EreignisRecord, ZyklusNr)
  WaitReturn = 0                       ;Voreinstellung = weiter an Paradox
  SWITCH
    CASE EreignisRecord ["TYPE"] = "KEY":
      Fkt = EreignisRecord ["KEYCODE"]
      SWITCH                           ;Tasten aus WAIT TABLE KEY-Liste
        CASE Fkt = ASC ("F1"):       Hilfe_F1 (FIELD ())
        CASE Fkt = ASC ("F3"):       Funktion_F3 ()
        CASE Fkt = ASC ("F33"):      AltFeld = " "
                                     Funktion_F3 ()
        CASE Fkt = ASC ("Esc") OR
             Fkt = ASC ("F2"):
          WaitReturn = 2               ;Ende von WAIT Bukonten -> Buchhltg
          HP_Tabelle = "Buchhltg"
        CASE Fkt = ASC ("F4") OR
             Fkt = ASC ("F5") OR
             Fkt = ASC ("F6") OR
             Fkt = ASC ("F7"):
          Gib_Hinweis ("Bitte Funktion im Buchungsfenster erneut aufrufen !", 1500)
          WaitReturn = 2               ;Ende von WAIT Bukonten -> Buchhltg
          HP_Tabelle = "Buchhltg"
        CASE Fkt = ASC ("F8")  OR
             Fkt = ASC ("F9"):       Konto_Neu ()
        OTHERWISE:
          Gib_Hinweis ("Taste "+STRVAL (EreignisRecord ["KEYCODE"])
                      +" ist nicht definiert", 3000)
      ENDSWITCH
    CASE EreignisRecord ["MESSAGE"] = "MENUSELECT":
      Fkt = EreignisRecord ["MENUTAG"]
      SWITCH                           ;Menfunktionen aus ShowPulldown
        CASE Fkt = "CMD_Such":       Funktion_F3 ()
        CASE Fkt = "CMD_Kasse"   OR
             Fkt = "CMD_MwSt"    OR
             Fkt = "CMD_Summe_K" OR
             Fkt = "CMD_Summe_S" OR
             Fkt = "CMD_Summe_B" OR
             Fkt = "CMD_Summe_J" :
          Gib_Hinweis ("Bitte Funktion im Buchungsfenster erneut aufrufen !", 1500)
          WaitReturn = 2               ;Ende von WAIT Bukonten -> Buchhltg
          HP_Tabelle = "Buchhltg"
        CASE Fkt = "CMD_Edit" OR
             Fkt = "CMD_Konto" :       Konto_Neu ()
        CASE Fkt = "CMD_EndePDOX":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Quit"
        CASE Fkt = "CMD_EndeJa":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Ende"
        CASE Fkt = "CMD_EndeZiel":
          Eingabe_Zielpfad ()          ;bleibe im WAIT Buchhltg
        CASE Fkt = "CMD_EndeSicher":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Ende"
          MESSAGE "Datensicherung aktiv !"
          SAVETABLES                   ;alle Tabellen schliessen
          RUN NOSHELL "XCOPY.EXE *.* " + Zielpfad
        OTHERWISE:
          Gib_Hinweis ("Die Reaktion auf "+EreignisRecord ["MENUTAG"]
                      +" ist noch nicht programmiert !", 3000)
      ENDSWITCH                        ;von Switch Menutag
    OTHERWISE:
      Gib_Hinweis ("Das Ereignis "+EreignisRecord ["MESSAGE"]
                  +" ist noch nicht programmiert !", 3000)
  ENDSWITCH                            ;von Switch EreignisRecord
  RETURN WaitReturn
ENDPROC


;****************************************************************************
PROC Auswert_Multi (EreignisTyp, EreignisRecord, ZyklusNr)
  WaitReturn = 0                       ;Voreinstellung = weiter an Paradox
  SWITCH
    CASE EreignisRecord ["TYPE"] = "KEY":
      Fkt = EreignisRecord ["KEYCODE"]
      SWITCH                           ;Tasten aus WAIT TABLE KEY-Liste
        CASE Fkt = ASC ("F1"):       Hilfe_F1 (FIELD ())
        CASE Fkt = ASC ("F3"):       Funktion_F3 ()
        CASE Fkt = ASC ("F33"):      AltFeld = " "
                                     Funktion_F3 ()
        CASE Fkt = ASC ("Esc"):
          ECHO OFF                        
          DO_IT!                       ;Versuchen, Edit zu beenden
          WaitReturn = 2               ;Ende von WAIT Einglist -> Buchhltg
          HP_Tabelle = "Buchhltg"
        CASE Fkt = ASC ("F2"):
          ECHO OFF                        
          DO_IT!                       ;Versuchen, Edit zu beenden
          ADD "Einglist" "Buchhltg"    ;Eintrge bernehmen
          WaitReturn = 2               ;Ende von WAIT Einglist -> Buchhltg
          HP_Tabelle = "Buchhltg"
        CASE Fkt = ASC ("F4") OR
             Fkt = ASC ("F5") OR
             Fkt = ASC ("F6") OR
             Fkt = ASC ("F7") OR
             Fkt = ASC ("F8"):
          Gib_Hinweis ("Bitte Funktion im Buchungsfenster erneut aufrufen !", 1500)
          WaitReturn = 2               ;Ende von WAIT Einglist -> Buchhltg
          HP_Tabelle = "Buchhltg"
        ;CASE Fkt = ASC ("F9"):       
        OTHERWISE:
          Gib_Hinweis ("Taste "+STRVAL (EreignisRecord ["KEYCODE"])
                      +" ist nicht definiert", 3000)
      ENDSWITCH
    CASE EreignisRecord ["MESSAGE"] = "MENUSELECT":
      Fkt = EreignisRecord ["MENUTAG"]
      SWITCH                           ;Menfunktionen aus ShowPulldown
        CASE Fkt = "CMD_Such":       Funktion_F3 ()
        CASE Fkt = "CMD_Kasse"   OR
             Fkt = "CMD_MwSt"    OR
             Fkt = "CMD_Summe_K" OR
             Fkt = "CMD_Summe_S" OR
             Fkt = "CMD_Summe_B" OR
             Fkt = "CMD_Summe_J" :
          Gib_Hinweis ("Bitte Funktion im Buchungsfenster erneut aufrufen !", 1500)
          WaitReturn = 2               ;Ende von WAIT Einglist -> Buchhltg
          HP_Tabelle = "Buchhltg"
        CASE Fkt = "CMD_EndePDOX":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Quit"
        CASE Fkt = "CMD_EndeJa":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Ende"
        CASE Fkt = "CMD_EndeZiel":
          Eingabe_Zielpfad ()          ;bleibe im WAIT Buchhltg
        CASE Fkt = "CMD_EndeSicher":
          WaitReturn = 2               ;Ende von WAIT Buchhltg
          HP_Tabelle = "Ende"
          MESSAGE "Datensicherung aktiv !"
          SAVETABLES                   ;alle Tabellen schliessen
          RUN NOSHELL "XCOPY.EXE *.* " + Zielpfad
        OTHERWISE:
          Gib_Hinweis ("Die Reaktion auf "+EreignisRecord ["MENUTAG"]
                      +" ist noch nicht programmiert !", 3000)
      ENDSWITCH                        ;von Switch Menutag
    OTHERWISE:
      Gib_Hinweis ("Das Ereignis "+EreignisRecord ["MESSAGE"]
                  +" ist noch nicht programmiert !", 3000)
  ENDSWITCH                            ;von Switch EreignisRecord
  RETURN WaitReturn
ENDPROC



;============================ H A U P T P R O G R A M M =====================
CLEARALL                               ;leere Arbeitsflche
RELEASE VARS ALL
ECHO OFF
AltFeld   = SDIR ()                    ;Pfad des Makros Buchung ?
{Tools} {More} {Directory} TYPEIN AltFeld
ENTER                                  ;Eingabe besttigen
IF NOT ISFILE ("SAVEVARS.SC")
   THEN Zielpfad = AltFeld             ;Voreinstellung f. Datensicherung
        SAVEVARS Zielpfad              ;und als Makro speichern
ENDIF
PLAY "SAVEVARS"                        ;Beschreibt Variable Zielpfad

AltFeld   = " "                        ;fr Suchen / Weitersuchen
MaxTreffer= 0                          ;fr Suchen / Weitersuchen
Kasse     = 0                          ;fr Konto-Abfrage
Vorsteuer = 0                          ;fr MwSt-Abfrage
Umssteuer = 0                          ;dito
Taste     = 0                          ;Tastatur-Abfrage

ARRAY PromptStack [10]
PromptZeiger = 0

DYNARRAY Vorlagesatz []                ;fr Multi-Eingabe anlegen
 
ECHO NORMAL
Zeige_Menue ()

HP_Tabelle = "Buchhltg"
WHILE (HP_Tabelle <> "Ende") AND (HP_Tabelle <> "Quit")
  SWITCH
    CASE HP_Tabelle = "Buchhltg":
      ECHO OFF
      CLEARALL                         ;leere Arbeitsflche
      VIEW "Buchhltg"                  ;Standardformular
      IF NOT ISFORMVIEW ()
         THEN FORMKEY                  ;auf jeden Fall als Multirecord-Formular
      ENDIF
      MOVETO FIELD "Datum"
      LOCATE INDEXORDER BESTMATCH TODAY ()
      CTRLPGUP                         ;ein Record vorher mit Bildscroll
      CTRLPGDN                         ;zurck zum gefundenen Record
      WINMAX
      MENUENABLE "CMD_Kasse"
      MENUENABLE "CMD_MwSt"
      MENUENABLE "CMD_Summe"
      MENUENABLE "CMD_Summe_K"
      MENUENABLE "CMD_Summe_S"
      MENUENABLE "CMD_Summe_B"
      MENUENABLE "CMD_Summe_J"
      NeuPrompt ("Men mit F10 aktivieren, F1= Hilfe")
      ECHO NORMAL
      WAIT TABLE                       ;nur Tabelle BUCHHLTG bearbeitbar
        PROC    "Auswert_Buchung"      ;Auswertung bei...
        MESSAGE "MENUSELECT"           ;...Auswahl aus ShowPulldown (CMD_xxx) oder bei
        KEY     "F1","F2","F3","F33","F4","F5","F6","F7","F8","F9"
                                       ;...Auswahl aus Tasten siehe Men
      ENDWAIT
      Altprompt ()
    CASE HP_Tabelle = "Bukonten":
      ECHO OFF
      CLEARALL                         ;leere Arbeitsflche
      VIEW "Bukonten"                  ;Standardformular
      IF NOT ISFORMVIEW ()
         THEN FORMKEY                  ;auf jeden Fall als Multirecord-Formular
      ENDIF
      WINMAX
      MENUDISABLE "CMD_Kasse"
      MENUDISABLE "CMD_MwSt"
      MENUDISABLE "CMD_Summe"
      MENUDISABLE "CMD_Summe_K"
      MENUDISABLE "CMD_Summe_S"
      MENUDISABLE "CMD_Summe_B"
      MENUDISABLE "CMD_Summe_J"
      NeuPrompt ("vergleichbaren Eintrag aussuchen und mit F9= neues Konto anlegen, ESC= zurck")
      ECHO NORMAL
      WAIT TABLE                       ;nur Tabelle BUKONTEN bearbeitbar
        PROC    "Auswert_Konten"       ;Auswertung bei...
        MESSAGE "MENUSELECT"           ;...Auswahl aus ShowPulldown (CMD_xxx) oder bei
        KEY     "F1","F2","F3","F33","F4","F5","F6","F7","F8","F9","Esc"
                                       ;...Auswahl aus Tasten siehe Men
      ENDWAIT
      Altprompt ()
    CASE HP_Tabelle = "Einglist":
      ECHO OFF
      CLEARALL                         ;leere Arbeitsflche
      VIEW "Einglist"                  ;Standardformular
      MENUDISABLE "CMD_Kasse"
      MENUDISABLE "CMD_MwSt"
      MENUDISABLE "CMD_Summe"
      MENUDISABLE "CMD_Summe_K"
      MENUDISABLE "CMD_Summe_S"
      MENUDISABLE "CMD_Summe_B"
      MENUDISABLE "CMD_Summe_J"
      NeuPrompt ("vorhandenen Eintrag berarbeiten und vervielfltigen, F2= Fertig, ESC= zurck")
      EDITKEY
      COPYFROMARRAY Vorlagesatz        ;1. Eintrag vorbelegen
      IF NOT ISFORMVIEW ()
         THEN FORMKEY                  ;auf jeden Fall als Multirecord-Formular
      ENDIF
      WINMAX
      ECHO NORMAL
      WAIT TABLE                       ;nur Tabelle EINGLIST bearbeitbar
        PROC    "Auswert_Multi"        ;Auswertung bei...
        MESSAGE "MENUSELECT"           ;...Auswahl aus ShowPulldown (CMD_xxx) oder bei
        KEY     "F1","F2","F3","F33","F4","F5","F6","F7","F8","F9","Esc"
                                       ;...Auswahl aus Tasten siehe Men
      ENDWAIT
      Altprompt ()
  ENDSWITCH
ENDWHILE
PROMPT ""
CLEARPULLDOWN
IF HP_Tabelle = "Quit"
   THEN QUIT                           ;zurck zu Paradox
   ELSE EXIT                           ;zurck zu Windows
ENDIF
